/* waitdemo1.c - shows how parent pauses until child finishes
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define DELAY 2

int main()
{
   int newpid;

   printf("before: mypid is %d\n", getpid());

   if ( -1 == (newpid = fork()) )
   {
      perror("fork");
   }
   else if ( 0 == newpid )
   {
      // child code, new process takes a nap and then exits
      printf("child %d here. will sleep for %d seconds\n", getpid(), DELAY);
      sleep(DELAY);
      printf("child done. about to exit\n");
      exit(17);
   }
   else
   {
      // parent code, parent waits for child then prints a message
      int wait_rv; /* return value from wait() */
      wait_rv = wait(NULL);
      printf("done waiting for %d. Wait returned: %d\n", newpid, wait_rv);
   }

   return 0;
}
