/* waitdemo2.c - shows how parent gets child status
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define DELAY 5

int main()
{
   int newpid;

   printf("before: mypid is %d\n", getpid());

   if ( -1 == (newpid = fork()) )
   {
      perror("fork");
   }
   else if ( 0 == newpid )
   {
      // child code, new process takes a nap and then exits
      printf("child %d here. will sleep for %d seconds\n", getpid(), DELAY);
      sleep(DELAY);
      printf("child done. about to exit\n");
      exit(17);
   }
   else
   {
      // parent code, parent waits for child then prints a message
      int wait_rv; /* return value from wait() */
      int child_status;
      int high_8, low_7, bit_7;

      wait_rv = wait(&child_status);
      printf("done waiting for %d. Wait returned: %d\n", newpid, wait_rv);

      high_8 = child_status >> 8;     /* 1111 1111 0000 0000 */
      low_7  = child_status & 0x7F;   /* 0000 0000 0111 1111 */
      bit_7  = child_status & 0x80;   /* 0000 0000 1000 0000 */
      printf("status: exit=%d, sig=%d, core=%d\n", high_8, low_7, bit_7);
   }

   return 0;
}
